GanttChart Task Tree

Task Table

Smart.GanttChart's uses a Table component to display the tasks of the element. There are two types of items determined by their hierarchy that the element is using:

  • Table Row - represent a Task/Milestone. As such it doesn't allow nested items.
  • Table Tree Row - represent a Project. Allows nested items - subTasks of a Project. When the user clicks on the arrow infront of an Table Tree Row, if it has subTasks, the group will expand in order to view all the tasks that belong to the project or collapse to hide them. Collapsing/Expanding reflects on the Timeline as well.

Expanding/Collapsing the project affects the Timeline as well.

The columns of the Task Table are determined by the taskColumns property. This property represents an Array of objects. Each object defines a column with the follkowing properties:

  • label - determines the text that will appear as the header of the column. The label property can be used in conjunction with messages in order to provide quick localization. Here's an example:
    const ganttChart = document.querySelector('smart-gantt-chart');
    
    gantt.taskColumns = [
            {
                label: 'columnLabel',
                value: 'label',
                size: '60%'
            }
            ...
    ];
    
    gantt.messages = {
            'en': {
                ...
                'columnLabel': 'Task Name'
                ...
            },
            'de': {
                ...
                'columnLabel': 'Aufgabennname',
                ...
            },
    

    Note: The demo used in this section is available on the website: Link

  • value - Determines the content of the Table items that will be created for each task. The value should match a task property, e.g. dateStart, dateEnd, label, duration, etc. If it doesn't the column will still be created but the Table rows will not be populated with content. This can be used to create a column with custom content using the formatFunction.
  • size - determines the size of the column. The size can be in percentages or pixels.
  • min - determines the minimal size of the column. The size can be in percentages or pixels.
  • max - determines the maximal size of the column. The size can be in percentages or pixels.
  • formatFunction - a callback that determines the content of the Table rows that will be created for each task. Can be used to completely customize the content. The function has two paramenters - the value of the property determined by the value attribute defined earlier for each Task and item - the item object if any.
    ...
     ganttChart.taskColumns = [
          {
                ...
    
                //Custom format function
                formatFunction: function (label) {
                    if (label === 'Learn') {
                        return ' <i class="material-icons">&#xE80C;</i>' + label;
                    }
                    else if (label === 'Work') {
                        return ' <i class="material-icons">&#xE30A;</i>' + label;
                    }
                    else if (label === 'Travel') {
                        return ' <i class="material-icons">&#xE53D;</i>' + label;
                    }
                    else if (label === 'Eat') {
                        return ' <i class="material-icons">&#xE56C;</i>' + label;
                    }
                    else if (label === 'Shop') {
                        return ' <i class="material-icons">&#xE25C;</i>' + label;
                    }
                    else if (label === 'Train') {
                        return ' <i class="material-icons">&#xE52F;</i>' + label;
                    }
                    else {
                        return label;
                    }
                }
            }
            ...
    ];
                             

Note: The demo used in this section is available on the website: Link

Task Table Size

By default the GanttChart is devided in two components - Task Tree and Timeline. So it's necessary to control the size of the Task Tree. The following properties are available:
  • treeMin - Sets the minimal size of the Task Table. The size can be in percentages or pixels.
  • treeSize - Sets the size of the Task Table. By default it's set to '20%'.
...
ganttChart.treeMin = '10%';
ganttChart.treeSize = '20%';
...

By setting the size of the Task table to '20%' what's left of the width of the GanttChart will be used to render the Timeline.

Task Panel size

The GanttChart component contains two panels - task and resource panels. By default the Resource panel is not visible unless there are resources defined. The Task panel is always visible.

The following properties allow to control the size of the Panels:

  • taskPanelSize - determines the size of the Task Panel when both Task and Resource panels are visible.
  • taskPanelMin - determines the min size of the Task Panel when both Task and Resource panels are visible.
  • resourcePanelSize - determines the size of the Resource panel when visible
  • resourcePanelMin - determines the min size of the Resource panel when visible.

Keyboard Navigation

Keyboard navigation inside the Task Table is enabled by default when the element is focused.
Key Action
ArrowUp/ArrowDown Pressing the 'ArrowUp/ArrowDown' keys focuses the previous/next task in the table.
ArrowLeft/ArrowRight Pressing the 'ArrowLeft/ArrowRight' keys focuses the previous/next table cell.
Space Pressing 'Space' key will select/unselect the focused task.
Enter Pressing 'Enter' key will open the window editor to edit the task if possible.
Delete Pressing 'Delete' key will delete the task.
For AI tooling

Developer Quick Reference

Topic: gantt-task-tree   Component: GanttChart   Framework: JavaScript

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: Modern browsers / Web Components   API access pattern: const component = document.querySelector(...) + component.method()

Lifecycle guidance: Initialize configuration first, then invoke imperative API when element is available in DOM.

Common pitfalls:

  • Calling methods before element initialization.
  • Reassigning large configuration partially without understanding merge behavior.
  • Missing required module script import for component type.

Validation checklist:

  • Ensure module scripts and CSS are loaded once.
  • Keep data schema aligned with columns/series definitions.
  • Verify method calls target initialized component instance.

GanttChart Task Tree

GanttChart for React

React version of this topic (compatible with React 19+). Keep the same configuration logic from JavaScript and pass it as component props.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import React, { useMemo, useRef } from 'react';
import { GanttChart } from 'smart-webcomponents-react/ganttchart';
import 'smart-webcomponents-react/source/styles/smart.default.css';

export default function App() {
  const componentRef = useRef(null);
  const componentProps = useMemo(() => ({
    // Copy this topic's JavaScript configuration here.
  }), []);

  return <GanttChart ref={componentRef} {...componentProps}></GanttChart>;
}

Use componentRef.current for API methods in this topic.

Task Table

Smart.GanttChart's uses a Table component to display the tasks of the element. There are two types of items determined by their hierarchy that the element is using:

  • Table Row - represent a Task/Milestone. As such it doesn't allow nested items.
  • Table Tree Row - represent a Project. Allows nested items - subTasks of a Project. When the user clicks on the arrow infront of an Table Tree Row, if it has subTasks, the group will expand in order to view all the tasks that belong to the project or collapse to hide them. Collapsing/Expanding reflects on the Timeline as well.

Expanding/Collapsing the project affects the Timeline as well.

The columns of the Task Table are determined by the taskColumns property. This property represents an Array of objects. Each object defines a column with the follkowing properties:

  • label - determines the text that will appear as the header of the column. The label property can be used in conjunction with messages in order to provide quick localization. Here's an example:
    const ganttChart = document.querySelector('smart-gantt-chart');
    
    gantt.taskColumns = [
            {
                label: 'columnLabel',
                value: 'label',
                size: '60%'
            }
            ...
    ];
    
    gantt.messages = {
            'en': {
                ...
                'columnLabel': 'Task Name'
                ...
            },
            'de': {
                ...
                'columnLabel': 'Aufgabennname',
                ...
            },
    

    Note: The demo used in this section is available on the website: Link

  • value - Determines the content of the Table items that will be created for each task. The value should match a task property, e.g. dateStart, dateEnd, label, duration, etc. If it doesn't the column will still be created but the Table rows will not be populated with content. This can be used to create a column with custom content using the formatFunction.
  • size - determines the size of the column. The size can be in percentages or pixels.
  • min - determines the minimal size of the column. The size can be in percentages or pixels.
  • max - determines the maximal size of the column. The size can be in percentages or pixels.
  • formatFunction - a callback that determines the content of the Table rows that will be created for each task. Can be used to completely customize the content. The function has two paramenters - the value of the property determined by the value attribute defined earlier for each Task and item - the item object if any.
    ...
     componentRef.current.taskColumns = [
          {
                ...
    
                //Custom format function
                formatFunction: function (label) {
                    if (label === 'Learn') {
                        return ' <i class="material-icons">&#xE80C;</i>' + label;
                    }
                    else if (label === 'Work') {
                        return ' <i class="material-icons">&#xE30A;</i>' + label;
                    }
                    else if (label === 'Travel') {
                        return ' <i class="material-icons">&#xE53D;</i>' + label;
                    }
                    else if (label === 'Eat') {
                        return ' <i class="material-icons">&#xE56C;</i>' + label;
                    }
                    else if (label === 'Shop') {
                        return ' <i class="material-icons">&#xE25C;</i>' + label;
                    }
                    else if (label === 'Train') {
                        return ' <i class="material-icons">&#xE52F;</i>' + label;
                    }
                    else {
                        return label;
                    }
                }
            }
            ...
    ];
                             

Note: The demo used in this section is available on the website: Link

Task Table Size

By default the GanttChart is devided in two components - Task Tree and Timeline. So it's necessary to control the size of the Task Tree. The following properties are available:
  • treeMin - Sets the minimal size of the Task Table. The size can be in percentages or pixels.
  • treeSize - Sets the size of the Task Table. By default it's set to '20%'.
...
componentRef.current.treeMin = '10%';
componentRef.current.treeSize = '20%';
...

By setting the size of the Task table to '20%' what's left of the width of the GanttChart will be used to render the Timeline.

Task Panel size

The GanttChart component contains two panels - task and resource panels. By default the Resource panel is not visible unless there are resources defined. The Task panel is always visible.

The following properties allow to control the size of the Panels:

  • taskPanelSize - determines the size of the Task Panel when both Task and Resource panels are visible.
  • taskPanelMin - determines the min size of the Task Panel when both Task and Resource panels are visible.
  • resourcePanelSize - determines the size of the Resource panel when visible
  • resourcePanelMin - determines the min size of the Resource panel when visible.

Keyboard Navigation

Keyboard navigation inside the Task Table is enabled by default when the element is focused.
Key Action
ArrowUp/ArrowDown Pressing the 'ArrowUp/ArrowDown' keys focuses the previous/next task in the table.
ArrowLeft/ArrowRight Pressing the 'ArrowLeft/ArrowRight' keys focuses the previous/next table cell.
Space Pressing 'Space' key will select/unselect the focused task.
Enter Pressing 'Enter' key will open the window editor to edit the task if possible.
Delete Pressing 'Delete' key will delete the task.
For AI tooling

Developer Quick Reference

Topic: gantt-task-tree   Component: GanttChart   Framework: React

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: React 19+   API access pattern: const componentRef = useRef(null) + componentRef.current.method()

Lifecycle guidance: Use useMemo for large config objects and call imperative API through componentRef.current after first render.

Common pitfalls:

  • Recreating columns/dataSource objects on every render can reset component state.
  • Calling API methods before ref is available causes runtime errors.
  • Mixing controlled and imperative updates without sync can lead to stale UI.

Validation checklist:

  • Keep config objects memoized when possible.
  • Guard API calls with ref existence checks.
  • Verify CSS theme import is present once per app.

GanttChart Task Tree

GanttChart for Vue

Vue 3 version using Smart custom elements and template refs.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

<script setup>
import { onMounted, ref } from 'vue';
import 'smart-webcomponents/source/styles/smart.default.css';
import 'smart-webcomponents/source/modules/smart.ganttchart.js';

const component = ref();
const componentProps = {
  // Copy this topic's JavaScript configuration here.
};

onMounted(() => {
  Object.assign(component.value, componentProps);
});
</script>

<template>
  <smart-gantt-chart ref="component"></smart-gantt-chart>
</template>

Use component.value for API methods in this topic.

Task Table

Smart.GanttChart's uses a Table component to display the tasks of the element. There are two types of items determined by their hierarchy that the element is using:

  • Table Row - represent a Task/Milestone. As such it doesn't allow nested items.
  • Table Tree Row - represent a Project. Allows nested items - subTasks of a Project. When the user clicks on the arrow infront of an Table Tree Row, if it has subTasks, the group will expand in order to view all the tasks that belong to the project or collapse to hide them. Collapsing/Expanding reflects on the Timeline as well.

Expanding/Collapsing the project affects the Timeline as well.

The columns of the Task Table are determined by the taskColumns property. This property represents an Array of objects. Each object defines a column with the follkowing properties:

  • label - determines the text that will appear as the header of the column. The label property can be used in conjunction with messages in order to provide quick localization. Here's an example:
    const ganttChart = document.querySelector('smart-gantt-chart');
    
    gantt.taskColumns = [
            {
                label: 'columnLabel',
                value: 'label',
                size: '60%'
            }
            ...
    ];
    
    gantt.messages = {
            'en': {
                ...
                'columnLabel': 'Task Name'
                ...
            },
            'de': {
                ...
                'columnLabel': 'Aufgabennname',
                ...
            },
    

    Note: The demo used in this section is available on the website: Link

  • value - Determines the content of the Table items that will be created for each task. The value should match a task property, e.g. dateStart, dateEnd, label, duration, etc. If it doesn't the column will still be created but the Table rows will not be populated with content. This can be used to create a column with custom content using the formatFunction.
  • size - determines the size of the column. The size can be in percentages or pixels.
  • min - determines the minimal size of the column. The size can be in percentages or pixels.
  • max - determines the maximal size of the column. The size can be in percentages or pixels.
  • formatFunction - a callback that determines the content of the Table rows that will be created for each task. Can be used to completely customize the content. The function has two paramenters - the value of the property determined by the value attribute defined earlier for each Task and item - the item object if any.
    ...
     component.value.taskColumns = [
          {
                ...
    
                //Custom format function
                formatFunction: function (label) {
                    if (label === 'Learn') {
                        return ' <i class="material-icons">&#xE80C;</i>' + label;
                    }
                    else if (label === 'Work') {
                        return ' <i class="material-icons">&#xE30A;</i>' + label;
                    }
                    else if (label === 'Travel') {
                        return ' <i class="material-icons">&#xE53D;</i>' + label;
                    }
                    else if (label === 'Eat') {
                        return ' <i class="material-icons">&#xE56C;</i>' + label;
                    }
                    else if (label === 'Shop') {
                        return ' <i class="material-icons">&#xE25C;</i>' + label;
                    }
                    else if (label === 'Train') {
                        return ' <i class="material-icons">&#xE52F;</i>' + label;
                    }
                    else {
                        return label;
                    }
                }
            }
            ...
    ];
                             

Note: The demo used in this section is available on the website: Link

Task Table Size

By default the GanttChart is devided in two components - Task Tree and Timeline. So it's necessary to control the size of the Task Tree. The following properties are available:
  • treeMin - Sets the minimal size of the Task Table. The size can be in percentages or pixels.
  • treeSize - Sets the size of the Task Table. By default it's set to '20%'.
...
component.value.treeMin = '10%';
component.value.treeSize = '20%';
...

By setting the size of the Task table to '20%' what's left of the width of the GanttChart will be used to render the Timeline.

Task Panel size

The GanttChart component contains two panels - task and resource panels. By default the Resource panel is not visible unless there are resources defined. The Task panel is always visible.

The following properties allow to control the size of the Panels:

  • taskPanelSize - determines the size of the Task Panel when both Task and Resource panels are visible.
  • taskPanelMin - determines the min size of the Task Panel when both Task and Resource panels are visible.
  • resourcePanelSize - determines the size of the Resource panel when visible
  • resourcePanelMin - determines the min size of the Resource panel when visible.

Keyboard Navigation

Keyboard navigation inside the Task Table is enabled by default when the element is focused.
Key Action
ArrowUp/ArrowDown Pressing the 'ArrowUp/ArrowDown' keys focuses the previous/next task in the table.
ArrowLeft/ArrowRight Pressing the 'ArrowLeft/ArrowRight' keys focuses the previous/next table cell.
Space Pressing 'Space' key will select/unselect the focused task.
Enter Pressing 'Enter' key will open the window editor to edit the task if possible.
Delete Pressing 'Delete' key will delete the task.
For AI tooling

Developer Quick Reference

Topic: gantt-task-tree   Component: GanttChart   Framework: Vue

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: Vue 3+   API access pattern: const component = ref() + component.value.method()

Lifecycle guidance: Use template refs with

GanttChart Task Tree

GanttChart for Angular

Angular standalone version of this topic (compatible with Angular 17+). Import both the Smart UI component and module in the standalone component.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { RouterOutlet } from '@angular/router';
import { GanttChartComponent, GanttChartModule } from 'smart-webcomponents-angular/ganttchart';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CommonModule, GanttChartModule, RouterOutlet],
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css'],
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  @ViewChild('ganttChart', { read: GanttChartComponent, static: false }) ganttChart!: GanttChartComponent;
}
<!-- app.component.html -->
<smart-gantt-chart #ganttChart></smart-gantt-chart>

Use this.ganttChart for API methods in this topic.

Task Table

Smart.GanttChart's uses a Table component to display the tasks of the element. There are two types of items determined by their hierarchy that the element is using:

  • Table Row - represent a Task/Milestone. As such it doesn't allow nested items.
  • Table Tree Row - represent a Project. Allows nested items - subTasks of a Project. When the user clicks on the arrow infront of an Table Tree Row, if it has subTasks, the group will expand in order to view all the tasks that belong to the project or collapse to hide them. Collapsing/Expanding reflects on the Timeline as well.

Expanding/Collapsing the project affects the Timeline as well.

The columns of the Task Table are determined by the taskColumns property. This property represents an Array of objects. Each object defines a column with the follkowing properties:

  • label - determines the text that will appear as the header of the column. The label property can be used in conjunction with messages in order to provide quick localization. Here's an example:
    const ganttChart = document.querySelector('smart-gantt-chart');
    
    gantt.taskColumns = [
            {
                label: 'columnLabel',
                value: 'label',
                size: '60%'
            }
            ...
    ];
    
    gantt.messages = {
            'en': {
                ...
                'columnLabel': 'Task Name'
                ...
            },
            'de': {
                ...
                'columnLabel': 'Aufgabennname',
                ...
            },
    

    Note: The demo used in this section is available on the website: Link

  • value - Determines the content of the Table items that will be created for each task. The value should match a task property, e.g. dateStart, dateEnd, label, duration, etc. If it doesn't the column will still be created but the Table rows will not be populated with content. This can be used to create a column with custom content using the formatFunction.
  • size - determines the size of the column. The size can be in percentages or pixels.
  • min - determines the minimal size of the column. The size can be in percentages or pixels.
  • max - determines the maximal size of the column. The size can be in percentages or pixels.
  • formatFunction - a callback that determines the content of the Table rows that will be created for each task. Can be used to completely customize the content. The function has two paramenters - the value of the property determined by the value attribute defined earlier for each Task and item - the item object if any.
    ...
     this.ganttChart.taskColumns = [
          {
                ...
    
                //Custom format function
                formatFunction: function (label) {
                    if (label === 'Learn') {
                        return ' <i class="material-icons">&#xE80C;</i>' + label;
                    }
                    else if (label === 'Work') {
                        return ' <i class="material-icons">&#xE30A;</i>' + label;
                    }
                    else if (label === 'Travel') {
                        return ' <i class="material-icons">&#xE53D;</i>' + label;
                    }
                    else if (label === 'Eat') {
                        return ' <i class="material-icons">&#xE56C;</i>' + label;
                    }
                    else if (label === 'Shop') {
                        return ' <i class="material-icons">&#xE25C;</i>' + label;
                    }
                    else if (label === 'Train') {
                        return ' <i class="material-icons">&#xE52F;</i>' + label;
                    }
                    else {
                        return label;
                    }
                }
            }
            ...
    ];
                             

Note: The demo used in this section is available on the website: Link

Task Table Size

By default the GanttChart is devided in two components - Task Tree and Timeline. So it's necessary to control the size of the Task Tree. The following properties are available:
  • treeMin - Sets the minimal size of the Task Table. The size can be in percentages or pixels.
  • treeSize - Sets the size of the Task Table. By default it's set to '20%'.
...
this.ganttChart.treeMin = '10%';
this.ganttChart.treeSize = '20%';
...

By setting the size of the Task table to '20%' what's left of the width of the GanttChart will be used to render the Timeline.

Task Panel size

The GanttChart component contains two panels - task and resource panels. By default the Resource panel is not visible unless there are resources defined. The Task panel is always visible.

The following properties allow to control the size of the Panels:

  • taskPanelSize - determines the size of the Task Panel when both Task and Resource panels are visible.
  • taskPanelMin - determines the min size of the Task Panel when both Task and Resource panels are visible.
  • resourcePanelSize - determines the size of the Resource panel when visible
  • resourcePanelMin - determines the min size of the Resource panel when visible.

Keyboard Navigation

Keyboard navigation inside the Task Table is enabled by default when the element is focused.
Key Action
ArrowUp/ArrowDown Pressing the 'ArrowUp/ArrowDown' keys focuses the previous/next task in the table.
ArrowLeft/ArrowRight Pressing the 'ArrowLeft/ArrowRight' keys focuses the previous/next table cell.
Space Pressing 'Space' key will select/unselect the focused task.
Enter Pressing 'Enter' key will open the window editor to edit the task if possible.
Delete Pressing 'Delete' key will delete the task.
For AI tooling

Developer Quick Reference

Topic: gantt-task-tree   Component: GanttChart   Framework: Angular

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: Angular 17+ (standalone)   API access pattern: @ViewChild(...) + this.component.method()

Lifecycle guidance: Bind inputs declaratively and call imperative API through @ViewChild in/after ngAfterViewInit.

Common pitfalls:

  • Using @ViewChild API too early (before view init).
  • Omitting standalone imports for Smart modules in @Component.imports.
  • Type mismatches between configuration fields and template bindings.

Validation checklist:

  • Ensure module import exists in standalone component imports array.
  • Use typed @ViewChild(..., { read: ComponentType }).
  • Call imperative methods after view initialization.